/*
 * Satyr.cpp
 *
 *  Created on: Oct 6, 2008
 *      Author: Santi
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif

#include "debug.h"

#include "Satyr.h"
#include "KObjectCreator.h"

#include "Knightmare.h"

Satyr::Satyr(int x,int y,int sfx_volume,GLTManager *GLTM) : KEnemy(x,y,sfx_volume)
{
	int i;

	m_class = satyr_symbol;

    m_n_states = 1;
    m_state_animations = new Animation *[1];

    for(i=0;i<1;i++) m_state_animations[i]=0;

    m_state = 0;

	Animation *a = new Animation(true);
	a->addFrame(GLTM->get("satyr_walk_001"),4);
	a->addFrame(GLTM->get("satyr_walk_002"),4);
	a->addFrame(GLTM->get("satyr_walk_003"),4);
	a->addFrame(GLTM->get("satyr_walk_004"),4);
	a->addFrame(GLTM->get("satyr_walk_005"),4);
	a->addFrame(GLTM->get("satyr_walk_006"),4);
	m_state_animations[0]=a;

}


Satyr::~Satyr() {
}


bool Satyr::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	KEnemy::cycle(vcl,game,GLTM,SFXM);

	m_y+=1.0f;

	if (m_y>game->get_map_position()+500) return false;

	return true;
}


bool Satyr::is_a(Symbol *c)
{
    if (c->cmp(satyr_symbol))
        return true;

    return KEnemy::is_a(c);
} /* Satyr::is_a */


bool Satyr::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);

    retval = is_a(s);

    delete s;

    return retval;
} /* Satyr::is_a */
